using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Diagnostics;


namespace Csp2dotnet
{
    public partial class MainForm : Form
    {

        ParamInfo[] Description = {
                        new ParamInfo( "Code 39", 0x1f ),    
                        new ParamInfo( "UPC", 0x09 ),
                        new ParamInfo( "Code128",  0x08),
                        new ParamInfo( "Code 39 Full ASCII", 0x36 ),
                        new ParamInfo( "UPC Supps", 0x35 ),
                        new ParamInfo( "Convert  UPC E to A", 0x29 ),
                        new ParamInfo( "Convert EAN8 to EAN13", 	0x2a ),
                        new ParamInfo( "Convert EAN8 to EAN13 Type", 0x37 ),
                        new ParamInfo( "Send UPC A Check Digit",	0x2b ),
                        new ParamInfo( "Send UPC E Check Digit", 0x2c ),
                        new ParamInfo( "Code 39 Check Digit", 0x2e ),
                        new ParamInfo( "Xmit Code 39 Check Digit", 0x2d ),
                        new ParamInfo( "UPCE_ Preamble", 0x25 ),
                        new ParamInfo( "UPCA_ Preamble", 0x24 ),
                        new ParamInfo( "EAN 128", 0x34 ),
                        new ParamInfo( "Coupon Code", 0x38),
                        new ParamInfo( "I 2of5", 0x3A ),
                        new ParamInfo( "I 2of5 Check Digit", 0x41 ),
                        new ParamInfo( "Xmit I 2of5 Check Digit", 0x40 ),
                        new ParamInfo( "Convert ITF14 to EAN 13", 0x3F ),
                        new ParamInfo( "I 2of5 Length 1",0x3B ),
                        new ParamInfo( "I 2of5 Length 2",0x3C ),
                        new ParamInfo( "D 2of5", 0x39 ),
                        new ParamInfo( "D 2of5  Length 1" ,0x3D ),
                        new ParamInfo( "D 2of5  Length 2", 0x3E ),
                        new ParamInfo( "Upcean Security Level", 0x2f ),
                        new ParamInfo( "UPC/EAN Supplemental Redundancy", 0x30 ),
                        new ParamInfo( "Scanner On-Time",0x11 ),
                        new ParamInfo( "Comm Awake Time", 0x20 ),
                        new ParamInfo( "Baud Rate ",0x0d ),
                        new ParamInfo( "Baud Switch Delay", 0x1d),
                        new ParamInfo( "Reset Baud Rates", 0x1c ),
                        new ParamInfo( "Reject Redundant Barcode", 0x04 ),
                        new ParamInfo( "Host Connect Beep ", 0x0a ),
                        new ParamInfo( "Host Complete Beep", 0x0b ),
                        new ParamInfo( "Low-Battery Indication", 0x07),
                        new ParamInfo( "Auto_Clear", 0x0f),
                        new ParamInfo( "Delete_Enable",0x21),
                        new ParamInfo( "Data Protection", 0x31 ),
                        new ParamInfo( "Memory Full Indication", 0x32 ),
                        new ParamInfo( "Memory Low Indication", 0x33 ),
                        new ParamInfo( "Max Barcode Len", 0x22 ),
                        new ParamInfo( "Good Decode LED On Time", 0x1e ),
                        new ParamInfo( "Store_RTC ", 0x23 ),
                        new ParamInfo( "ASCII mode", 0x4f ),
                        new ParamInfo( "Buzzer Volume",0x02 ),
                        new ParamInfo( "Buzzer On",0x57 ),
                        new ParamInfo( "Buzzer Toggle", 0x55 ),
                        new ParamInfo( "Buzzer Auto On", 0x56 ),
                        new ParamInfo( "RSS", 0x14 ),
                        //new ParamInfo( "Scratch Pad", 0x26 ),
        };


        //Opticon.csp2 csp2connection;
        
        void CallbackFunction( )
        {
            Trace.WriteLine("OPN-2001 Connected");
        }

        public MainForm()
        {
            InitializeComponent();

        }
        
        public void  Test()
        {

            Int32 iRet;

            Trace.WriteLine("csp2.SetDebugMode(...)");
            iRet = Opticon.csp2.SetDebugMode(1);
            if (iRet != 0)
            {
                Trace.WriteLine(" Fail!");
            }

            Trace.WriteLine("csp2.GetDLLVersion(...)");

            StringBuilder szDLLVersion = new StringBuilder(256);
            iRet = Opticon.csp2.GetDllVersion(szDLLVersion, 100);
            if (iRet < 0)
            {
                Trace.WriteLine(String.Format(" Fail! {0} ", iRet));
            }
            else
            {
                Trace.WriteLine(String.Format("DLL Version = {0}", szDLLVersion));
            }



            Trace.WriteLine("csp2.Init(...)");
            try
            {
                iRet = Opticon.csp2.Init( Int32.Parse( textBox1.Text ));
            }
            catch( Exception ex )
            {
                Trace.WriteLine( "Port Error" + ex.Message);
                return;
            }
            if (iRet != 0)
            {
                Trace.WriteLine(String.Format(" Fail! {0} ", iRet));
            }

            Trace.WriteLine("csp2.Interogate() ");
            iRet = Opticon.csp2.Interrogate();
            if (iRet != 0)
            {
                Trace.WriteLine(String.Format("Fail! {0} ", iRet));
            }

            Trace.WriteLine("csp2.StartPolling()");
            iRet = Opticon.csp2.StartPolling(new Opticon.csp2.csp2CallBackFunction(CallbackFunction));
            if (iRet != 0)
            {
                Trace.WriteLine(" Fail");
            }

            Trace.WriteLine("csp2.EnablePolling()");
            iRet = Opticon.csp2.EnablePolling();
            if (iRet != 0)
            {
                Trace.WriteLine(" Fail!");
            }

            Trace.WriteLine("csp2.DisablePolling()");
            iRet = Opticon.csp2.DisablePolling();
            if (iRet != 0)
            {
                Trace.WriteLine(" Fail!");
            }

            Trace.WriteLine("csp2.StopPolling()");
            iRet = Opticon.csp2.StopPolling();
            if (iRet != 0)
            {
                Trace.WriteLine(" Fail!");
            }

            Trace.WriteLine("csp2.DataAvailable");
            iRet = Opticon.csp2.DataAvailable();
            if (iRet < 0)
            {
                Trace.WriteLine(" Fail!");
            }else
            if (iRet == 0)
            {
                Trace.WriteLine(" No data available!");
            }
            else
            {
                Trace.WriteLine(" Data available!");
                Trace.WriteLine("csp2.ReadRawData(...)");

                Byte[] rawData = new Byte[2000];
                Opticon.csp2.WakeUp();
                Opticon.csp2.Interrogate();
                int iSize = Opticon.csp2.ReadRawData(rawData, rawData.Length );
                StringBuilder sb = new StringBuilder(100);
                if (iSize > 0)
                {
                    rawData = new Byte[iSize];
                    iRet = Opticon.csp2.ReadRawData(rawData, iSize);
                    
                    for (int x = 0; x < iSize; x++)
                    {
                        if (x % 16 == 0 )
                        {
                            sb.AppendLine("");
                        }
                        sb.AppendFormat("{0:X02},", rawData[x]);
                        //Trace.Write(String.Format("{0:X02},", rawData[x]));
                    }
                    Trace.WriteLine(sb);
                }
                else
                {
                    Trace.WriteLine(String.Format(" Fail! {0}", iSize ));
                }
            }

            Trace.WriteLine("csp2.SetTime to 2-2-1991 12:30:00");
            Byte[] TimeBuffer = new Byte[6];
            DateTime T = new DateTime(1991, 2, 2, 12, 30, 0);
            iRet = Opticon.csp2.SetTime( T );
            if (iRet == 0)
            {
                Trace.WriteLine("csp2.GetTime");
                iRet = Opticon.csp2.GetTime( out T ) ;
                if (iRet == 0)
                {
                    Trace.WriteLine(String.Format(" {0}", T.ToString()));

                }
                else
                {
                    Trace.WriteLine(" Fail!");
                }

                Trace.WriteLine("csp2.SetTime to DateTime.Now");
                iRet = Opticon.csp2.SetTime( DateTime.Now );
                if ( iRet == 0 )
                {
                    iRet = Opticon.csp2.GetTime( out T );
                    if (iRet == 0)
                    {
                        Trace.WriteLine(String.Format(" {0}", T));
                    }
                    else
                    {
                        Trace.WriteLine(" Fail!");
                    }
                }
            }


            Trace.WriteLine("csp2.ReadData()");
            iRet = Opticon.csp2.ReadData();
            if (iRet < 0)
            {
                Trace.WriteLine(" Fail!");
            }
            else
            {
                Int32 iCount = iRet;
                Trace.WriteLine(String.Format("Number of barcodes = {0}", iCount));

                /*
                csp2GetDeviceId()
                csp2GetProtocol()
                csp2GetSystemStatus()
                csp2GetSwVersion()
                */

                String szDeviceId;
                iRet = Opticon.csp2.GetDeviceId( out szDeviceId );
                Trace.WriteLine(String.Format("Device Id: {0}", szDeviceId));

                Trace.WriteLine(String.Format("Protocol: {0}", Opticon.csp2.GetProtocol()));

                Trace.WriteLine(String.Format("SystemStatus: {0}", Opticon.csp2.GetSystemStatus()));

                StringBuilder szSoftwareVersion = new StringBuilder(256);
                Opticon.csp2.GetSwVersion(szSoftwareVersion, 256);

                Trace.WriteLine(String.Format("Software version: {0}", szSoftwareVersion));


                //Byte[] aBarData = new Byte[100];

                Trace.WriteLine("Bar codes");

                StringBuilder sbBarcodes = new StringBuilder(1000);

                for (Int32 i = 0; i < iCount; i++)
                {
                    Opticon.csp2.BarCodeDataPacket aPacket;
                    iRet = Opticon.csp2.GetPacket( out aPacket, i);
                    sbBarcodes.AppendLine(String.Format("{0}, {1}, {2}, {3}", i + 1, aPacket.strBarData, aPacket.dtTimestamp, aPacket.strId));
                    //Trace.WriteLine(String.Format("{0}, {1}, {2}, {3}", i + 1, aPacket.strBarData, aPacket.dtTimestamp, aPacket.strId));
                }
                Trace.WriteLine(sbBarcodes);

                Trace.WriteLine("csp2.GetParameter()");
                
                Byte[] value = new Byte[100];
                foreach( ParamInfo p in Description )
                {
                    iRet = Opticon.csp2.GetParam( p.ParamNumber , value, value.Length );
                    if( iRet == 0 )
                        Trace.WriteLine(String.Format(" Param {0:X02}, {1} = {2}", p.ParamNumber, p.Parameter, value[0]));
                    else
                        Trace.WriteLine(String.Format(" Param {0:X02}, {1} Failed!", p.ParamNumber, p.Parameter));
                }
                
                Trace.WriteLine("csp2.Restore()");
                iRet = Opticon.csp2.Restore();
                if (iRet != 0)
                {
                    Trace.WriteLine( String.Format(" Fail! {0}", iRet ));
                }
            }
        }

        private void button1_Click(object sender, EventArgs e)
        {
            try
            {
                Test();
            }
            catch (Exception ex)
            {
                Trace.WriteLine( ex.Message );
            }
        }
    }
    public class ParamInfo
    {
        public ParamInfo(String Par, int Num)
        {
            _Parameter = Par;
            _ParamNumber = Num;
            _ParamValue = -1;

        }
        private String _Parameter;
        public String Parameter
        {
            get { return _Parameter; }
            set { _Parameter = value; }
        }

        private int _ParamNumber;
        public int ParamNumber
        {
            get { return _ParamNumber; }
            set { _ParamNumber = value; }
        }

        private int _ParamValue;
        public int ParamValue
        {
            get { return _ParamValue; }
            set { _ParamValue = value; }
        }
    }
}